package
{
	public class Randomizer
	{
	   private var min:Number = 0;
       private var max:Number = 100;
       private var nominalMin:Number = 0;
       private var nominalMax:Number = 100;
       private var primaryNominalMin:Number = 0;
       private var primaryNominalMax:Number = 100;
       private var minIncrement:Number = 0;
       private var maxIncrement:Number = 5;
       private var directionWeighting:int = 75;
       private var nominalWeighting:int = 40;
                                  
       private var spikeWeighting:int = 2;    
       private var spikeLength:int = 10;   

       private var secondaryNominalMin:Number = 0;  
       private var secondaryNominalMax:Number = 100;
       private var switchNominalWeighting:Number = 0;
                      
       private var outputValue:Number = 0;
       private var direction:int = 1; 
       private var remainingSpikeLength:int = 0;
       
   
       public function Randomizer(initValue:Number,min:Number,max:Number,increment:Number)
       {
           this.outputValue = initValue;
           this.min = min;
           this.max = max;
           this.nominalMin = min;
           this.nominalMax = max;
           this.minIncrement = 0;
           this.maxIncrement= increment;
       }
   
	   public function get Min():Number { return min; }
	   public function set Min(value:Number):void { this.min=value; }
       
       public function get Max():Number { return max; }
       public function set Max(value:Number):void { this.max=value; }
       
       
       public function get NominalMin():Number { return primaryNominalMin; }
       public function set NominalMin(value:Number):void
       {
       	 	nominalMin = value;
            primaryNominalMin = value;
       }

	   public function get NominalMax():Number { return primaryNominalMax; }
	   public function set NominalMax(value:Number):void 
	   {
	   		nominalMax = value;
            primaryNominalMax = value;
	   }
	   
	   public function get SecondaryNominalMin():Number { return secondaryNominalMin; }
	   public function set SecondaryNominalMin(value:Number):void { secondaryNominalMin=value; }
	   
	   public function get SecondaryNominalMax():Number { return secondaryNominalMax; }
	   public function set SecondaryNominalMax(value:Number):void { secondaryNominalMax=value; }

	   public function get SwitchNominalWeighting():Number { return switchNominalWeighting; }
	   public function set SwitchNominalWeighting(value:Number):void { switchNominalWeighting=value; }
       
       public function get MinIncrement():Number { return minIncrement; }
       public function set MinIncrement(value:Number):void { minIncrement=value; }
       
       public function get MaxIncrement():Number { return maxIncrement; }
       public function set MaxIncrement(value:Number):void { maxIncrement=value; }
		
	   public function get DirectionWeighting():int { return directionWeighting; }
	   public function set DirectionWeighting(value:int):void { directionWeighting=value; }
       
	   public function get NominalWeighting():int { return nominalWeighting; }
	   public function set NominalWeighting(value:int):void { nominalWeighting=value; }
       
	   public function get SpikeWeighting():int { return spikeWeighting; }
	   public function set SpikeWeighting(value:int):void { spikeWeighting=value; }

	   public function get SpikeLength():int { return spikeLength; }
	   public function set SpikeLength(value:int):void { spikeLength=value; }

	   private function getRand(minOrRange:Number, max:Number = NaN):Number {
	   		if (isNaN(max))
	   			return Math.random()*minOrRange;
	   		return minOrRange + Math.random()*(max - minOrRange);
	   }

       public function GenerateNextValue():Number
       {
           if ( switchNominalWeighting > 0 )
           {
               if ( outputValue >= nominalMin && outputValue <= nominalMax )
               {
                   if (getRand(100) <= switchNominalWeighting )
                   {
                       if ( nominalMin == primaryNominalMin && nominalMax == primaryNominalMax )
                       {
                           nominalMin = secondaryNominalMin;
                           nominalMax = secondaryNominalMax;
                       }
                       else
                       {
                           nominalMin = primaryNominalMin;
                           nominalMax = primaryNominalMax;
                       }
                   }
               }
           }

           if ( spikeWeighting > 0 )
           {
               if ( getRand(100) <= spikeWeighting )
               {
                   remainingSpikeLength = spikeLength;
               }
           }

           
           if ( remainingSpikeLength == 0 )
           {
               if ( getRand(100) > directionWeighting ) 
                   direction *= -1;
               if ( outputValue <= nominalMin )
               {
                   if ( getRand(100) < nominalWeighting )
                       direction = 1;
               }
               if(outputValue >= nominalMax)
               {
                   if ( getRand(100) < nominalWeighting )
                       direction = -1;
               }
           }
           else
           {
               remainingSpikeLength--;
           }
           if ( outputValue <= min )
               direction = 1;
           if ( outputValue >= max )
               direction = -1;
           
           outputValue += direction * (Number(this.getRand(int(minIncrement*100),int(maxIncrement*100))) / 100);

           outputValue = Math.max(outputValue, this.min);
           outputValue = Math.min(outputValue, this.max);

           return outputValue;
       }

	}
}